<template>
  <div class="app-collection cards">
    <div
      v-show="is_loading"
      class="loader"
    >
      <img
        :src="loading_image"
        class="loader__image"
        alt="loader"
      >
    </div>

    <header class="appup__header">
      <!-- @slot Use this slot for header -->
      <slot name="header"></slot>
    </header>

    <main class="appup__body container-fluid">
      <div class="row">
        <div
          v-for="item in data"
          :key="item.id"
          class="appup__item col col-md-4 col-lg-3"
        >
          <!-- @slot Use this slot body for each item in response -->
          <slot name="body" :item="item"></slot>
        </div>
      </div>

      <div
        v-show="load_more_type === 'loadMoreButton'"
        ref="loader_div"
        class="load-more text-center mt-2"
      >
        <!--
          @slot Slot for load more button, shown only if load_more_type is 'loadMoreButton'
          and there is more data to fetch
        -->
        <slot name="load_more_button"></slot>
      </div>
    </main>

    <footer class="appup__footer">
      <!-- @slot Use this slot for footer -->
      <slot name="footer"></slot>
    </footer>
  </div>
</template>

<script>
import AppData from './mixins/appup-data'

/**
 * Appup Colection component which can be used to display data from API
 * @requires VueBootstrap
 * @requires appup-data.js
 */
export default {
  name: 'appup-collection',

  mixins: [AppData],

  props: {
    /**
     * @param {string} loading_image - Image to show while loading data
     */
    loading_image: {
      type: String,
      required: true,
    },

    /**
     * @param {string} load_more_type - Type of loading more information
     * @default loadMoreButton
     * 'loadMoreButton, infiniScroll'
     */
    load_more_type: {
      type: String,
      default: 'loadMoreButton',
      validator: value => ['loadMoreButton', 'infiniScroll'].indexOf(value) !== -1,
    },
  },

  mounted() {
    /**
    * If prop load_more_type is infiniScroll then add listener for scroll
    * when scroll reaches bottom of page then load more data
    */
    if (this.load_more_type === 'infiniScroll') {
      window.onscroll = () => {
        if ((window.innerHeight + window.scrollY) >= document.body.offsetHeight) {
          if (!this.is_loading) {
            this.has_more()
          }
        }
      }
    }
  },

  beforeDestroy() {
    /**
    * Remove scroll listener when component about to destroy
    */
    window.onscroll = () => {}
  },
}
</script>

<style scoped>
  .appup__item {
    display: flex;
    flex-wrap: wrap;
  }

  .loader {
    position: fixed;
    display: flex;
    align-items: center;
    justify-content: center;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    z-index: 999;
    background-color: rgba(255, 255, 255, .65);
  }

  .loader__image {
    width: 100px;
    height: 100px;
  }
</style>
